diff --git a/doc/guides/linux_gsg/intro.rst b/doc/guides/linux_gsg/intro.rst
index eef7e83..a812f5c 100644
--- a/doc/guides/linux_gsg/intro.rst
+++ b/doc/guides/linux_gsg/intro.rst
@@ -31,7 +31,7 @@
 Introduction
 ============
 
-This document contains instructions for installing and configuring the Intel® Data Plane Development Kit (DPDK) software.
+This document contains instructions for installing and configuring the Data Plane Development Kit (DPDK) software.
 It is designed to get customers up and running quickly.
 The document describes how to compile and run a DPDK application in a Linux application (linuxapp) environment,
 without going deeply into detail.
diff --git a/doc/guides/nics/intel_vf.rst b/doc/guides/nics/intel_vf.rst
index db86c64..a68198f 100644
--- a/doc/guides/nics/intel_vf.rst
+++ b/doc/guides/nics/intel_vf.rst
@@ -278,7 +278,7 @@ For example,
         rmmod igb (To remove the igb module)
         insmod igb max_vfs=2,2 (To enable two Virtual Functions per port)
 
-*   Using Intel®  DPDK PMD PF igb driver:
+*   Using DPDK PMD PF igb driver:
 
     Kernel Params: iommu=pt, intel_iommu=on modprobe uio
 
diff --git a/doc/guides/nics/pcap_ring.rst b/doc/guides/nics/pcap_ring.rst
index 46aa3ac..aa48d33 100644
--- a/doc/guides/nics/pcap_ring.rst
+++ b/doc/guides/nics/pcap_ring.rst
@@ -45,7 +45,7 @@ the DPDK also includes two pure-software PMDs. These two drivers are:
     The libpcap -based PMD is disabled by default in the build configuration files,
     owing to an external dependency on the libpcap development files which must be installed on the board.
     Once the libpcap development files are installed,
-    the library can be enabled by setting CONFIG_RTE_LIBRTE_PMD_PCAP=y and recompiling the Intel®  DPDK.
+    the library can be enabled by setting CONFIG_RTE_LIBRTE_PMD_PCAP=y and recompiling the DPDK.
 
 Using the Drivers from the EAL Command Line
 -------------------------------------------
diff --git a/doc/guides/prog_guide/extend_intel_dpdk.rst b/doc/guides/prog_guide/extend_dpdk.rst
similarity index 100%
rename from doc/guides/prog_guide/extend_intel_dpdk.rst
rename to doc/guides/prog_guide/extend_dpdk.rst
diff --git a/doc/guides/prog_guide/index.rst b/doc/guides/prog_guide/index.rst
index 9359f2e..a9404fb 100644
--- a/doc/guides/prog_guide/index.rst
+++ b/doc/guides/prog_guide/index.rst
@@ -53,7 +53,7 @@ Programmer's Guide
     ip_fragment_reassembly_lib
     multi_proc_support
     kernel_nic_interface
-    thread_safety_intel_dpdk_functions
+    thread_safety_dpdk_functions
     qos_framework
     power_man
     packet_classif_access_ctrl
@@ -63,7 +63,7 @@ Programmer's Guide
     source_org
     dev_kit_build_system
     dev_kit_root_make_help
-    extend_intel_dpdk
+    extend_dpdk
     build_app
     ext_app_lib_make_help
     perf_opt_guidelines
diff --git a/doc/guides/prog_guide/thread_safety_intel_dpdk_functions.rst b/doc/guides/prog_guide/thread_safety_dpdk_functions.rst
similarity index 100%
rename from doc/guides/prog_guide/thread_safety_intel_dpdk_functions.rst
rename to doc/guides/prog_guide/thread_safety_dpdk_functions.rst
diff --git a/doc/guides/rel_notes/known_issues.rst b/doc/guides/rel_notes/known_issues.rst
index 9f1fcdb..b782091 100644
--- a/doc/guides/rel_notes/known_issues.rst
+++ b/doc/guides/rel_notes/known_issues.rst
@@ -163,7 +163,7 @@ Not all variants of supported NIC types have been used in testing
 
 **Description**:
    The supported network interface cards can come in a number of variants with different device ID's.
-   Not all of these variants have been tested with the Intel® DPDK.
+   Not all of these variants have been tested with the DPDK.
 
    The NIC device identifiers used during testing:
 
@@ -210,7 +210,7 @@ Multi-process sample app requires exact memory mapping
    A multi-process client application fails to initialize.
 
 **Resolution/Workaround**:
-   See the "Multi-process Limitations" section in the Intel®  DPDK Programmer's Guide for more information.
+   See the "Multi-process Limitations" section in the DPDK Programmer's Guide for more information.
 
 **Affected Environment/Platform**:
    All.
@@ -468,7 +468,7 @@ GCC might generate Intel® AVX instructions for processors without Intel® AVX s
 ------------------------------------------------------------------------------------
 
 **Description**:
-   When compiling Intel®  DPDK (and any DPDK app), gcc may generate Intel® AVX instructions, even when the
+   When compiling DPDK (and any DPDK app), gcc may generate Intel® AVX instructions, even when the
    processor does not support Intel® AVX.
 
 **Implication**:
diff --git a/doc/guides/sample_app_ug/cmd_line.rst b/doc/guides/sample_app_ug/cmd_line.rst
index 6a72959..02a295f 100644
--- a/doc/guides/sample_app_ug/cmd_line.rst
+++ b/doc/guides/sample_app_ug/cmd_line.rst
@@ -45,7 +45,7 @@ to debug a DPDK application, in a Linux* application environment.
 .. note::
 
     The rte_cmdline library should not be used in production code since
-    it is not validated to the same standard as other Intel®  DPDK libraries.
+    it is not validated to the same standard as other DPDK libraries.
     See also the "rte_cmdline library should not be used in production code due to limited testing" item
     in the "Known Issues" section of the Release Notes.
 
diff --git a/examples/ip_pipeline/config/tm_profile.cfg b/examples/ip_pipeline/config/tm_profile.cfg
index 53edb67..2dfb215 100644
--- a/examples/ip_pipeline/config/tm_profile.cfg
+++ b/examples/ip_pipeline/config/tm_profile.cfg
@@ -41,7 +41,7 @@
 ;         are set to 1:1:1:1
 ;
 ; For more details, please refer to chapter "Quality of Service (QoS) Framework"
-; of Intel Data Plane Development Kit (Intel DPDK) Programmer's Guide.
+; of Data Plane Development Kit (DPDK) Programmer's Guide.
 
 ; Port configuration
 [port]
diff --git a/examples/qos_sched/profile.cfg b/examples/qos_sched/profile.cfg
index 10180c2..f5b704c 100644
--- a/examples/qos_sched/profile.cfg
+++ b/examples/qos_sched/profile.cfg
@@ -41,7 +41,7 @@
 ;         are set to 1:1:1:1
 ;
 ; For more details, please refer to chapter "Quality of Service (QoS) Framework"
-; of Intel Data Plane Development Kit (Intel DPDK) Programmer's Guide.
+; of Data Plane Development Kit (DPDK) Programmer's Guide.
 
 ; Port configuration
 [port]
diff --git a/lib/librte_eal/common/include/rte_common.h b/lib/librte_eal/common/include/rte_common.h
index b58a384..332f2a4 100644
--- a/lib/librte_eal/common/include/rte_common.h
+++ b/lib/librte_eal/common/include/rte_common.h
@@ -38,7 +38,7 @@
  * @file
  *
  * Generic, commonly-used macro and inline function definitions
- * for Intel DPDK.
+ * for DPDK.
  */
 
 #ifdef __cplusplus
diff --git a/lib/librte_eal/common/include/rte_eal.h b/lib/librte_eal/common/include/rte_eal.h
index d2816a8..0e99c31 100644
--- a/lib/librte_eal/common/include/rte_eal.h
+++ b/lib/librte_eal/common/include/rte_eal.h
@@ -86,7 +86,7 @@ struct rte_config {
 
 	/**
 	 * Pointer to memory configuration, which may be shared across multiple
-	 * Intel DPDK instances
+	 * DPDK instances
 	 */
 	struct rte_mem_config *mem_config;
 } __attribute__((__packed__));
diff --git a/lib/librte_eal/common/include/rte_version.h b/lib/librte_eal/common/include/rte_version.h
index 6b1890e..0baf130 100644
--- a/lib/librte_eal/common/include/rte_version.h
+++ b/lib/librte_eal/common/include/rte_version.h
@@ -33,7 +33,7 @@
 
 /**
  * @file
- * Definitions of Intel(R) DPDK version numbers
+ * Definitions of DPDK version numbers
  */
 
 #ifndef _RTE_VERSION_H_
diff --git a/lib/librte_pipeline/rte_pipeline.h b/lib/librte_pipeline/rte_pipeline.h
index 5459324..7302a62 100644
--- a/lib/librte_pipeline/rte_pipeline.h
+++ b/lib/librte_pipeline/rte_pipeline.h
@@ -42,7 +42,7 @@ extern "C" {
  * @file
  * RTE Pipeline
  *
- * This tool is part of the Intel DPDK Packet Framework tool suite and provides
+ * This tool is part of the DPDK Packet Framework tool suite and provides
  * a standard methodology (logically similar to OpenFlow) for rapid development
  * of complex packet processing pipelines out of ports, tables and actions.
  *
diff --git a/lib/librte_port/rte_port.h b/lib/librte_port/rte_port.h
index 00b97a9..c3c5348 100644
--- a/lib/librte_port/rte_port.h
+++ b/lib/librte_port/rte_port.h
@@ -42,7 +42,7 @@ extern "C" {
  * @file
  * RTE Port
  *
- * This tool is part of the Intel DPDK Packet Framework tool suite and provides
+ * This tool is part of the DPDK Packet Framework tool suite and provides
  * a standard interface to implement different types of packet ports.
  *
  ***/
diff --git a/lib/librte_table/rte_table.h b/lib/librte_table/rte_table.h
index 720514e..d3446a5 100644
--- a/lib/librte_table/rte_table.h
+++ b/lib/librte_table/rte_table.h
@@ -42,7 +42,7 @@ extern "C" {
  * @file
  * RTE Table
  *
- * This tool is part of the Intel DPDK Packet Framework tool suite and provides
+ * This tool is part of the DPDK Packet Framework tool suite and provides
  * a standard interface to implement different types of lookup tables for data
  * plane processing.
  *