diff --git a/doc/guides/howto/img/lm_vhost_user.svg b/doc/guides/howto/img/lm_vhost_user.svg
new file mode 100644
index 0000000..35cf4d0
--- /dev/null
+++ b/doc/guides/howto/img/lm_vhost_user.svg
@@ -0,0 +1,644 @@
+<?xml version="1.0" encoding="UTF-8" standalone="no"?>
+<!-- Created with Inkscape (http://www.inkscape.org/) -->
+
+<svg
+   xmlns:dc="http://purl.org/dc/elements/1.1/"
+   xmlns:cc="http://creativecommons.org/ns#"
+   xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#"
+   xmlns:svg="http://www.w3.org/2000/svg"
+   xmlns="http://www.w3.org/2000/svg"
+   xmlns:sodipodi="http://sodipodi.sourceforge.net/DTD/sodipodi-0.dtd"
+   xmlns:inkscape="http://www.inkscape.org/namespaces/inkscape"
+   width="1052.8693"
+   height="762.99158"
+   id="svg2"
+   version="1.1"
+   inkscape:version="0.48.4 r9939"
+   sodipodi:docname="lm_vhost_user.svg">
+  <defs
+     id="defs4">
+    <inkscape:perspective
+       sodipodi:type="inkscape:persp3d"
+       inkscape:vp_x="0 : 372.04724 : 1"
+       inkscape:vp_y="0 : 1000 : 0"
+       inkscape:vp_z="1052.3622 : 372.04724 : 1"
+       inkscape:persp3d-origin="526.18109 : 248.03149 : 1"
+       id="perspective3886" />
+  </defs>
+  <sodipodi:namedview
+     id="base"
+     pagecolor="#ffffff"
+     bordercolor="#666666"
+     borderopacity="1.0"
+     inkscape:pageopacity="0.0"
+     inkscape:pageshadow="2"
+     inkscape:zoom="0.70710678"
+     inkscape:cx="201.38434"
+     inkscape:cy="397.3839"
+     inkscape:document-units="px"
+     inkscape:current-layer="layer1"
+     showgrid="true"
+     inkscape:window-width="1432"
+     inkscape:window-height="1000"
+     inkscape:window-x="93"
+     inkscape:window-y="-26"
+     inkscape:window-maximized="0"
+     inkscape:snap-page="false"
+     inkscape:snap-grids="false"
+     showguides="true"
+     inkscape:guide-bbox="true"
+     fit-margin-top="0.1"
+     fit-margin-left="0.1"
+     fit-margin-right="0.1"
+     fit-margin-bottom="0.3">
+    <inkscape:grid
+       type="xygrid"
+       id="grid3174"
+       empspacing="5"
+       visible="true"
+       enabled="true"
+       snapvisiblegridlinesonly="true"
+       spacingx="0.5px"
+       spacingy="0.5px"
+       originx="1780.3521px"
+       originy="-176.4939px" />
+    <sodipodi:guide
+       position="1780.3521,-176.4939"
+       orientation="0,744.09448"
+       id="guide3176" />
+    <sodipodi:guide
+       position="2524.4467,-176.4939"
+       orientation="-1052.3622,0"
+       id="guide3178" />
+    <sodipodi:guide
+       position="3103.2093,1429.2206"
+       orientation="0,-744.09448"
+       id="guide3180" />
+    <sodipodi:guide
+       position="826.06645,1429.2206"
+       orientation="1052.3622,0"
+       id="guide3182" />
+    <sodipodi:guide
+       orientation="0,1"
+       position="2524.4467,565.50611"
+       id="guide3079" />
+    <sodipodi:guide
+       orientation="0,1"
+       position="2494.3521,579.00611"
+       id="guide3081" />
+    <sodipodi:guide
+       orientation="0,1"
+       position="2437.3521,579.00611"
+       id="guide3083" />
+    <sodipodi:guide
+       position="-8.2192466,-76.99225"
+       orientation="0,4077.6428"
+       id="guide3649" />
+    <sodipodi:guide
+       position="4069.4236,-76.99225"
+       orientation="-1720.5,0"
+       id="guide3651" />
+    <sodipodi:guide
+       position="4069.4236,1643.5079"
+       orientation="0,-4077.6428"
+       id="guide3653" />
+    <sodipodi:guide
+       position="-8.2192466,1643.5079"
+       orientation="1720.5,0"
+       id="guide3655" />
+    <sodipodi:guide
+       position="-8.2192466,-76.99225"
+       orientation="0,4077.6428"
+       id="guide3657" />
+    <sodipodi:guide
+       position="4069.4236,-76.99225"
+       orientation="-1720.5,0"
+       id="guide3659" />
+    <sodipodi:guide
+       position="4069.4236,1643.5079"
+       orientation="0,-4077.6428"
+       id="guide3661" />
+    <sodipodi:guide
+       position="-8.2192466,1643.5079"
+       orientation="1720.5,0"
+       id="guide3663" />
+  </sodipodi:namedview>
+  <metadata
+     id="metadata7">
+    <rdf:RDF>
+      <cc:Work
+         rdf:about="">
+        <dc:format>image/svg+xml</dc:format>
+        <dc:type
+           rdf:resource="http://purl.org/dc/dcmitype/StillImage" />
+        <dc:title />
+      </cc:Work>
+    </rdf:RDF>
+  </metadata>
+  <g
+     inkscape:label="Layer 1"
+     inkscape:groupmode="layer"
+     id="layer1"
+     transform="translate(1780.3522,-112.87834)">
+    <rect
+       style="fill:#0000ff;fill-rule:evenodd;stroke:#000000;stroke-width:0.36521944px;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1"
+       id="rect2985"
+       width="349.80563"
+       height="212.77235"
+       x="-1780.0696"
+       y="115.28934"
+       ry="38.183765" />
+    <rect
+       style="fill:#0000ff;fill-rule:evenodd;stroke:#000000;stroke-width:1.5459187px;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1"
+       id="rect3755"
+       width="0"
+       height="0"
+       x="-629.48682"
+       y="1001.1993" />
+    <rect
+       style="fill:#0000ff;fill-opacity:1"
+       id="rect3191"
+       width="358.58792"
+       height="214.06038"
+       x="-1087.5042"
+       y="112.97834"
+       ry="38.183765" />
+    <rect
+       style="fill:#a000ff;fill-opacity:1"
+       id="rect3195"
+       width="350.58966"
+       height="174.45921"
+       x="-1779.1808"
+       y="349.60342"
+       ry="39.59798" />
+    <rect
+       style="fill:#a000ff;fill-opacity:1"
+       id="rect3197"
+       width="357.25491"
+       height="170.35497"
+       x="-1084.8379"
+       y="353.79617"
+       ry="38.183765" />
+    <rect
+       style="fill:#a000ff;fill-opacity:1"
+       id="rect3199"
+       width="687.849"
+       height="55.655697"
+       x="-1603.3909"
+       y="687.73035"
+       ry="24.04163" />
+    <rect
+       style="fill:#a000ff;fill-opacity:1"
+       id="rect3201"
+       width="447.90167"
+       height="50.114544"
+       x="-1488.6338"
+       y="825.45538"
+       ry="19.658308" />
+    <rect
+       style="opacity:0.60399996;fill:#0000ff;fill-opacity:1"
+       id="rect3046"
+       width="135.97015"
+       height="38.530865"
+       x="-1679.87"
+       y="524.00964" />
+    <text
+       xml:space="preserve"
+       style="font-size:18.55102539px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:125%;letter-spacing:0px;word-spacing:0px;writing-mode:lr-tb;text-anchor:start;fill:#000000;fill-opacity:1;stroke:none;font-family:Sans;-inkscape-font-specification:Sans"
+       x="-1565.7183"
+       y="170.28043"
+       id="text3052"
+       sodipodi:linespacing="125%"
+       inkscape:transform-center-x="-310.5984"
+       inkscape:transform-center-y="14.984243"
+       transform="scale(1.1160112,0.89604834)"><tspan
+         sodipodi:role="line"
+         id="tspan3054"
+         x="-1565.7183"
+         y="170.28043">VM 1 </tspan></text>
+    <text
+       xml:space="preserve"
+       style="font-size:18.55102539px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:125%;letter-spacing:0px;word-spacing:0px;writing-mode:lr-tb;text-anchor:start;fill:#000000;fill-opacity:1;stroke:none;font-family:Sans;-inkscape-font-specification:Sans"
+       x="-1268.2957"
+       y="803.349"
+       id="text3056"
+       sodipodi:linespacing="125%"
+       inkscape:transform-center-x="-645.19167"
+       inkscape:transform-center-y="8.043534"
+       transform="scale(1.1160112,0.89604834)"><tspan
+         sodipodi:role="line"
+         id="tspan3058"
+         x="-1268.2957"
+         y="803.349">Switch with 10Gb ports</tspan><tspan
+         sodipodi:role="line"
+         x="-1268.2957"
+         y="826.53778"
+         id="tspan3060" /></text>
+    <text
+       xml:space="preserve"
+       style="font-size:18.55102539px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:125%;letter-spacing:0px;word-spacing:0px;writing-mode:lr-tb;text-anchor:start;fill:#000000;fill-opacity:1;stroke:none;font-family:Sans;-inkscape-font-specification:Sans"
+       x="-1573.7157"
+       y="433.78815"
+       id="text3062"
+       sodipodi:linespacing="125%"
+       transform="scale(1.1160112,0.89604835)"><tspan
+         sodipodi:role="line"
+         id="tspan3064"
+         x="-1573.7157"
+         y="433.78815">Server 1</tspan></text>
+    <text
+       xml:space="preserve"
+       style="font-size:18.55102539px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:125%;letter-spacing:0px;word-spacing:0px;writing-mode:lr-tb;text-anchor:start;fill:#000000;fill-opacity:1;stroke:none;font-family:Sans;-inkscape-font-specification:Sans"
+       x="-947.12897"
+       y="434.55573"
+       id="text3066"
+       sodipodi:linespacing="125%"
+       transform="scale(1.1160112,0.89604835)"><tspan
+         sodipodi:role="line"
+         id="tspan3068"
+         x="-947.12897"
+         y="434.55573">Server 2</tspan></text>
+    <text
+       xml:space="preserve"
+       style="font-size:18.55102539px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:125%;letter-spacing:0px;word-spacing:0px;writing-mode:lr-tb;text-anchor:start;fill:#000000;fill-opacity:1;stroke:none;font-family:Sans;-inkscape-font-specification:Sans"
+       x="-1251.1786"
+       y="957.94836"
+       id="text3070"
+       sodipodi:linespacing="125%"
+       transform="scale(1.1160112,0.89604835)"><tspan
+         sodipodi:role="line"
+         id="tspan3072"
+         x="-1251.1786"
+         y="957.94836">  10 Gb Traffic Generator</tspan></text>
+    <text
+       xml:space="preserve"
+       style="font-size:20.1229248px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:125%;letter-spacing:0px;word-spacing:0px;writing-mode:lr-tb;text-anchor:start;fill:#000000;fill-opacity:1;stroke:none;font-family:Sans;-inkscape-font-specification:Sans"
+       x="-1016.8596"
+       y="162.4848"
+       id="text3074"
+       sodipodi:linespacing="125%"
+       transform="scale(1.0288342,0.97197394)"
+       inkscape:transform-center-x="-374.58424"
+       inkscape:transform-center-y="19.26541"><tspan
+         sodipodi:role="line"
+         id="tspan3076"
+         x="-1016.8596"
+         y="162.4848">VM 2 </tspan></text>
+    <text
+       xml:space="preserve"
+       style="font-size:18.55102539px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:125%;letter-spacing:0px;word-spacing:0px;writing-mode:lr-tb;text-anchor:start;fill:#000000;fill-opacity:1;stroke:none;font-family:Sans;-inkscape-font-specification:Sans"
+       x="-1575.2013"
+       y="479.56177"
+       id="text3078"
+       sodipodi:linespacing="125%"
+       inkscape:transform-center-x="-405.24435"
+       transform="scale(1.1160112,0.89604835)"
+       inkscape:transform-center-y="-3.0408919e-05"><tspan
+         sodipodi:role="line"
+         id="tspan3080"
+         x="-1575.2013"
+         y="479.56177">Linux, KVM, QEMU 2.5 </tspan></text>
+    <text
+       xml:space="preserve"
+       style="font-size:18.93562508px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:125%;letter-spacing:0px;word-spacing:0px;writing-mode:lr-tb;text-anchor:start;fill:#000000;fill-opacity:1;stroke:none;font-family:Sans;-inkscape-font-specification:Sans"
+       x="-906.26202"
+       y="579.8208"
+       id="text3086"
+       sodipodi:linespacing="125%"
+       inkscape:transform-center-x="-152.77712"
+       inkscape:transform-center-y="6.9586675"
+       transform="scale(1.052991,0.94967574)"><tspan
+         sodipodi:role="line"
+         id="tspan3088"
+         x="-906.26202"
+         y="579.8208">10 Gb NIC</tspan></text>
+    <text
+       xml:space="preserve"
+       style="font-size:18.55102539px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:125%;letter-spacing:0px;word-spacing:0px;writing-mode:lr-tb;text-anchor:start;fill:#000000;fill-opacity:1;stroke:none;font-family:Sans;-inkscape-font-specification:Sans"
+       x="-1493.7568"
+       y="613.58636"
+       id="text3090"
+       sodipodi:linespacing="125%"
+       inkscape:transform-center-x="-174.62846"
+       transform="scale(1.1160112,0.89604835)"
+       inkscape:transform-center-y="2.3462468e-05"><tspan
+         sodipodi:role="line"
+         id="tspan3092"
+         x="-1493.7568"
+         y="613.58636">10 Gb NIC</tspan></text>
+    <rect
+       style="opacity:0.60199998;fill:#0000ff;fill-opacity:1"
+       id="rect3094"
+       width="125.30582"
+       height="38.530865"
+       x="-1427.5106"
+       y="437.27979" />
+    <rect
+       style="opacity:0.60799997;fill:#0000ff;fill-opacity:1"
+       id="rect3096"
+       width="111.97541"
+       height="41.741772"
+       x="-1196.8135"
+       y="437.27979" />
+    <text
+       xml:space="preserve"
+       style="font-size:19.30730629px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:125%;letter-spacing:0px;word-spacing:0px;writing-mode:lr-tb;text-anchor:start;fill:#000000;fill-opacity:1;stroke:none;font-family:Sans;-inkscape-font-specification:Sans"
+       x="-1322.4871"
+       y="491.82611"
+       id="text3098"
+       sodipodi:linespacing="125%"
+       transform="scale(1.0722964,0.93257795)"
+       inkscape:transform-center-x="-27.993731"
+       inkscape:transform-center-y="-6.9674825"><tspan
+         sodipodi:role="line"
+         id="tspan3100"
+         x="-1322.4871"
+         y="491.82611">10 Gb NIC</tspan></text>
+    <text
+       xml:space="preserve"
+       style="font-size:18.55102539px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:125%;letter-spacing:0px;word-spacing:0px;writing-mode:lr-tb;text-anchor:start;fill:#000000;fill-opacity:1;stroke:none;font-family:Sans;-inkscape-font-specification:Sans"
+       x="-1071.2081"
+       y="513.09308"
+       id="text3102"
+       sodipodi:linespacing="125%"
+       inkscape:transform-center-x="-670.51946"
+       inkscape:transform-center-y="150.91262"
+       transform="scale(1.1160112,0.89604834)"><tspan
+         sodipodi:role="line"
+         id="tspan3104"
+         x="-1071.2081"
+         y="513.09308">10 Gb NIC</tspan></text>
+    <rect
+       style="fill:#7878ff;fill-opacity:1"
+       id="rect3106"
+       width="277.07584"
+       height="100.60838"
+       x="-1043.5138"
+       y="187.8994" />
+    <rect
+       style="fill:#7878ff;fill-opacity:1"
+       id="rect3106-4"
+       width="268.59058"
+       height="100.60838"
+       x="-1748.0256"
+       y="184.68852" />
+    <text
+       xml:space="preserve"
+       style="font-size:18.55102539px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:125%;letter-spacing:0px;word-spacing:0px;writing-mode:lr-tb;text-anchor:start;fill:#000000;fill-opacity:1;stroke:none;font-family:Sans;-inkscape-font-specification:Sans"
+       x="-1557.907"
+       y="233.58643"
+       id="text3108-9"
+       sodipodi:linespacing="125%"
+       transform="scale(1.1160112,0.89604835)"><tspan
+         sodipodi:role="line"
+         id="tspan3110-5"
+         x="-1557.907"
+         y="233.58643">DPDK Testpmd App</tspan><tspan
+         sodipodi:role="line"
+         x="-1557.907"
+         y="256.77521"
+         id="tspan3347">or L2fwd App.</tspan></text>
+    <text
+       xml:space="preserve"
+       style="font-size:18.55102539px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:125%;letter-spacing:0px;word-spacing:0px;writing-mode:lr-tb;text-anchor:start;fill:#000000;fill-opacity:1;stroke:none;font-family:Sans;-inkscape-font-specification:Sans"
+       x="-1560.3652"
+       y="274.25635"
+       id="text3880-7"
+       sodipodi:linespacing="125%"
+       transform="scale(1.1160112,0.89604835)"><tspan
+         sodipodi:role="line"
+         id="tspan3882-9"
+         x="-1560.3652"
+         y="274.25635" /><tspan
+         sodipodi:role="line"
+         x="-1560.3652"
+         y="297.44513"
+         id="tspan3884-8">DPDK virtio PMD devices </tspan></text>
+    <text
+       xml:space="preserve"
+       style="font-size:18.55102539px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:125%;letter-spacing:0px;word-spacing:0px;writing-mode:lr-tb;text-anchor:start;fill:#000000;fill-opacity:1;stroke:none;font-family:Sans;-inkscape-font-specification:Sans"
+       x="-1576.4685"
+       y="504.73169"
+       id="text3951"
+       sodipodi:linespacing="125%"
+       transform="scale(1.1160112,0.89604834)"><tspan
+         sodipodi:role="line"
+         id="tspan3953"
+         x="-1576.4685"
+         y="504.73169">DPDK PF PMD</tspan></text>
+    <text
+       xml:space="preserve"
+       style="font-size:18.55102539px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:125%;letter-spacing:0px;word-spacing:0px;writing-mode:lr-tb;text-anchor:start;fill:#000000;fill-opacity:1;stroke:none;font-family:Sans;-inkscape-font-specification:Sans"
+       x="-947.43506"
+       y="500.51361"
+       id="text3951-4"
+       sodipodi:linespacing="125%"
+       transform="scale(1.1160112,0.89604835)"><tspan
+         sodipodi:role="line"
+         id="tspan3953-0"
+         x="-947.43506"
+         y="500.51361">DPDK PF PMD</tspan></text>
+    <text
+       xml:space="preserve"
+       style="font-size:18.55102539px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:125%;letter-spacing:0px;word-spacing:0px;writing-mode:lr-tb;text-anchor:start;fill:#000000;fill-opacity:1;stroke:none;font-family:Sans;-inkscape-font-specification:Sans"
+       x="-1203.7942"
+       y="195.3643"
+       id="text4007"
+       sodipodi:linespacing="125%"
+       transform="scale(1.1160112,0.89604834)"><tspan
+         sodipodi:role="line"
+         id="tspan4009"
+         x="-1203.7942"
+         y="195.3643">NFS Server</tspan><tspan
+         sodipodi:role="line"
+         x="-1203.7942"
+         y="218.55309"
+         id="tspan4011">VM disk image</tspan><tspan
+         sodipodi:role="line"
+         x="-1203.7942"
+         y="241.74187"
+         id="tspan4013" /></text>
+    <rect
+       style="opacity:0.45833333;fill:#a000ff;fill-opacity:1"
+       id="rect4015"
+       width="193.29091"
+       height="94.186569"
+       x="-1353.4641"
+       y="134.34897"
+       ry="22.627417" />
+    <rect
+       style="opacity:0.45833333;fill:#a000ff;fill-opacity:1"
+       id="rect3070"
+       width="17.329529"
+       height="11.773321"
+       x="-1278.1288"
+       y="744.45654" />
+    <rect
+       style="opacity:0.45833333;fill:#a000ff;fill-opacity:1"
+       id="rect3070-3"
+       width="19.995611"
+       height="11.773321"
+       x="-1280.1283"
+       y="813.47321" />
+    <path
+       style="fill:none;stroke:#000000;stroke-width:2.44584394px;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1"
+       d="m -1270.1392,756.51119 0.5585,54.21449"
+       id="path3090"
+       inkscape:connector-type="polyline"
+       inkscape:connector-curvature="3" />
+    <rect
+       style="opacity:0.59895833;fill:#0000ff;fill-opacity:1"
+       id="rect3046-7"
+       width="135.97015"
+       height="38.530865"
+       x="-981.50122"
+       y="523.78949" />
+    <rect
+       style="opacity:0.59375;fill:#a000ff;fill-opacity:1"
+       id="rect3880"
+       width="14.663447"
+       height="11.773321"
+       x="-1622.0532"
+       y="563.57544" />
+    <rect
+       style="opacity:0.59375;fill:#a000ff;fill-opacity:1"
+       id="rect3880-8"
+       width="14.663447"
+       height="11.773321"
+       x="-914.96075"
+       y="564.21674" />
+    <rect
+       style="opacity:0.59375;fill:#a000ff;fill-opacity:1"
+       id="rect3880-6"
+       width="14.663447"
+       height="11.773321"
+       x="-1482.7505"
+       y="674.35162" />
+    <rect
+       style="opacity:0.59375;fill:#a000ff;fill-opacity:1"
+       id="rect3880-9"
+       width="14.663447"
+       height="11.773321"
+       x="-1198.8129"
+       y="720.37451" />
+    <rect
+       style="opacity:0.59375;fill:#a000ff;fill-opacity:1"
+       id="rect3880-99"
+       width="14.663447"
+       height="11.773321"
+       x="-1085.5045"
+       y="674.35175" />
+    <rect
+       style="opacity:0.59375;fill:#a000ff;fill-opacity:1"
+       id="rect3880-82"
+       width="14.663447"
+       height="11.773321"
+       x="-1301.4569"
+       y="452.79913" />
+    <rect
+       style="opacity:0.59375;fill:#a000ff;fill-opacity:1"
+       id="rect3880-0"
+       width="14.663447"
+       height="11.773321"
+       x="-1210.8103"
+       y="452.79922" />
+    <path
+       style="fill:none;stroke:#000000;stroke-width:1.49161923px;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1"
+       d="m -1612.063,574.09703 136.6956,98.10634"
+       id="path3946"
+       inkscape:connector-type="polyline"
+       inkscape:connector-curvature="3" />
+    <path
+       style="fill:none;stroke:#000000;stroke-width:1.62650716px;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1"
+       d="m -906.09206,573.4328 -171.08524,98.7457"
+       id="path3948"
+       inkscape:connector-type="polyline"
+       inkscape:connector-curvature="3" />
+    <path
+       style="fill:none;stroke:#000000;stroke-width:1.54592061px;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1"
+       d="m -1291.5381,459.322 88.4734,2e-5"
+       id="path3950"
+       inkscape:connector-type="polyline"
+       inkscape:connector-curvature="3" />
+    <text
+       xml:space="preserve"
+       style="font-size:18.55102539px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:125%;letter-spacing:0px;word-spacing:0px;writing-mode:lr-tb;text-anchor:start;fill:#000000;fill-opacity:1;stroke:none;font-family:Sans;-inkscape-font-specification:Sans"
+       x="-1220.5167"
+       y="460.53635"
+       id="text3101"
+       sodipodi:linespacing="125%"
+       transform="scale(1.1160112,0.89604834)"><tspan
+         sodipodi:role="line"
+         id="tspan3103"
+         x="-1220.5167"
+         y="460.53635">10 Gb Migration Link</tspan></text>
+    <flowRoot
+       xml:space="preserve"
+       id="flowRoot3085"
+       style="font-size:12px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:125%;letter-spacing:0px;word-spacing:0px;writing-mode:lr-tb;text-anchor:start;fill:#000000;fill-opacity:1;stroke:none;font-family:Sans;-inkscape-font-specification:Sans"
+       transform="matrix(1.7252629,0,0,1.3852181,-1778.0192,-314.07213)"><flowRegion
+         id="flowRegion3087"><rect
+           id="rect3089"
+           width="1"
+           height="41.5"
+           x="-1"
+           y="701.59448" /></flowRegion><flowPara
+         id="flowPara3091" /></flowRoot>    <flowRoot
+       xml:space="preserve"
+       id="flowRoot3093"
+       style="font-size:12px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:125%;letter-spacing:0px;word-spacing:0px;writing-mode:lr-tb;text-anchor:start;fill:#000000;fill-opacity:1;stroke:none;font-family:Sans;-inkscape-font-specification:Sans"
+       transform="matrix(1.7252629,0,0,1.3852181,-1778.0192,-314.07213)"><flowRegion
+         id="flowRegion3095"><rect
+           id="rect3097"
+           width="1"
+           height="41"
+           x="-1.5"
+           y="700.59448" /></flowRegion><flowPara
+         id="flowPara3099" /></flowRoot>    <text
+       xml:space="preserve"
+       style="font-size:18.55102539px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:125%;letter-spacing:0px;word-spacing:0px;writing-mode:lr-tb;text-anchor:start;fill:#000000;fill-opacity:1;stroke:none;font-family:Sans;-inkscape-font-specification:Sans"
+       x="-927.84314"
+       y="233.94818"
+       id="text3108-9-3"
+       sodipodi:linespacing="125%"
+       transform="scale(1.1160112,0.89604835)"><tspan
+         sodipodi:role="line"
+         id="tspan3110-5-6"
+         x="-927.84314"
+         y="233.94818">DPDK Testpmd App</tspan><tspan
+         sodipodi:role="line"
+         x="-927.84314"
+         y="257.13696"
+         id="tspan3347-7">or L2fwd App.</tspan></text>
+    <text
+       xml:space="preserve"
+       style="font-size:18.55102539px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:125%;letter-spacing:0px;word-spacing:0px;writing-mode:lr-tb;text-anchor:start;fill:#000000;fill-opacity:1;stroke:none;font-family:Sans;-inkscape-font-specification:Sans"
+       x="-927.24658"
+       y="276.23499"
+       id="text3880-7-5"
+       sodipodi:linespacing="125%"
+       transform="scale(1.1160112,0.89604835)"><tspan
+         sodipodi:role="line"
+         id="tspan3882-9-3"
+         x="-927.24658"
+         y="276.23499" /><tspan
+         sodipodi:role="line"
+         x="-927.24658"
+         y="299.42377"
+         id="tspan3884-8-5">DPDK virtio PMD devices </tspan></text>
+    <text
+       xml:space="preserve"
+       style="font-size:18.55102539px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:125%;letter-spacing:0px;word-spacing:0px;writing-mode:lr-tb;text-anchor:start;fill:#000000;fill-opacity:1;stroke:none;font-family:Sans;-inkscape-font-specification:Sans"
+       x="-947.67664"
+       y="476.70486"
+       id="text3078-6"
+       sodipodi:linespacing="125%"
+       inkscape:transform-center-x="-405.24435"
+       transform="scale(1.1160112,0.89604835)"
+       inkscape:transform-center-y="-3.0408919e-05"><tspan
+         sodipodi:role="line"
+         id="tspan3080-2"
+         x="-947.67664"
+         y="476.70486">Linux, KVM, QEMU 2.5 </tspan></text>
+  </g>
+</svg>
diff --git a/doc/guides/howto/lm_virtio_vhost_user.rst b/doc/guides/howto/lm_virtio_vhost_user.rst
index dbcd1d3..c505772 100644
--- a/doc/guides/howto/lm_virtio_vhost_user.rst
+++ b/doc/guides/howto/lm_virtio_vhost_user.rst
@@ -49,6 +49,10 @@ The switch is configured to broadcast traffic on all the NIC ports.
 Live Migration with Virtio and vhost_user test setup:
 -----------------------------------------------------
 
+.. _figure_lm_vhost_user:
+
+.. figure:: img/lm_vhost_user.*
+
 Live Migration steps for VM with Virtio PMD and vhost_user on host:
 -------------------------------------------------------------------
 